/****************************************************************************/
/*	Purpose:	Driver for LCD Display 16x4									*/
/*	Version:	1.0															*/
/*	Author:		Mike Schaub													*/
/*	Date:		18.09.2005													*/
/*	www:		www.microcontroller-starterkits.de							*/
/*	email:																	*/
/*	Software:	WinARM to compile											*/
/*	Hardware:	LPC2194 with ARMEvoBoard									*/
/****************************************************************************/

#include "lpc21xx_keil.h"


#define  LCD_D4  0x00100000		//	P1.20
#define  LCD_D5  0x00200000		//	P1.21
#define  LCD_D6  0x00400000		//	P1.22
#define  LCD_D7  0x00800000		//	P1.23
#define  LCD_EN  0x00040000		//	P1.18
#define  LCD_RS  0x00010000		//	P1.16
#define  LCD_RW  0x00020000		//	P1.17

#define  LCD_DATA           (LCD_D4|LCD_D5|LCD_D6|LCD_D7)
#define  LCD_IOALL          (LCD_D4|LCD_D5|LCD_D6|LCD_D7|LCD_EN|LCD_RS|LCD_RW)

#define  LCD_GPIO_SEL0      0x00000000   //MASK for P0.04-P0.07
#define  LCD_GPIO_SEL1      0x00000000   //MASK for P0.22-P0.24


#define IN				0
#define DA				1
#define CLS				0x01
#define HOME			0x02
#define ENTRY			0x04
#define INCREMENT		0x02
#define DECREMENT		0x00
#define CONTROL			0x08
#define DISPLAY_ON		0x04
#define DISPLAY_OFF		0x00
#define CURSOR_ON		0x02
#define CURSOR_OFF		0x00
#define BLINK			0x01
#define NO_BLINK		0x00
#define SHIFT			0x10
#define SHI_LEFT		0x00
#define SHI_RIGHT		0x04
#define DIS_LEFT		0x08
#define DIS_RIGHT		0x0C
#define FUNKTION_SET	0x20
#define _8BIT			0x10
#define _4BIT			0x00
#define _2LINE			0x08
#define _1LINE			0x00
#define _10DOT			0x04
#define _7DOT			0x00

#define R_W		0x01
#define E		0x04

unsigned char		RS;

void itoa(unsigned int value, unsigned char * s);
void wait(unsigned int	dauer);
void clrscr(void);
void home(void);
void fourth_row(void);
void third_row(void);
void second_row(void);
void first_row(void);
void lcd_init(unsigned char line, unsigned char dots);
void lcd_out_data(unsigned char lcd_data);
void lcd_out(char c);
void put_lcd(const unsigned char * s);
void put_lcd_xy(unsigned int x, unsigned int y, const char * s);

